org.jboss.jca.deployers.fungal

## Class AbstractFungalRADeployer

- java.lang.Object
- - org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer
  - - org.jboss.jca.deployers.fungal.AbstractFungalRADeployer

- Direct Known Subclasses:
    RAActivator, RADeployer, RaXmlDeployer

      public abstract class AbstractFungalRADeployer
      extends org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer

  An abstract resource adapter deployer which contains common functionality for all resource adapter archive based deployers.
  Author:
    Jesper Pedersen

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected com.github.fungal.api.Kernel` | `kernel` The kernel

    - ### Fields inherited from class org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer

      `log, validateClasses`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractFungalRADeployer(boolean validateClasses)` Create a new AbstractResourceAdapterDeployer.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String[]` | `bindAdminObject(java.net.URL url, java.lang.String deployment, java.lang.Object ao)` Bind admin object into JNDI
    `java.lang.String[]` | `bindAdminObject(java.net.URL url, java.lang.String deployment, java.lang.Object ao, java.lang.String jndi)` Bind admin object into JNDI
    `java.lang.String[]` | `bindConnectionFactory(java.net.URL url, java.lang.String deployment, java.lang.Object cf)` Bind connection factory into JNDI
    `java.lang.String[]` | `bindConnectionFactory(java.net.URL url, java.lang.String deployment, java.lang.Object cf, java.lang.String jndi)` Bind connection factory into JNDI
    `protected boolean` | `checkConfigurationIsValid()` check if the configuration for this deployer has been set to a valid value
    `protected org.jboss.jca.core.api.connectionmanager.ccm.CachedConnectionManager` | `getCachedConnectionManager()` Get the cached connection manager
    `com.github.fungal.api.Kernel` | `getKernel()` Get the kernel
    `protected java.io.PrintWriter` | `getLogPrintWriter()` get a PrintWriter where logger will put its output
    `protected java.io.File` | `getReportDirectory()` get The directory where write error reports
    `protected org.jboss.jca.core.spi.security.SubjectFactory` | `getSubjectFactory(org.jboss.jca.common.api.metadata.common.SecurityMetadata securityMetadata, java.lang.String jndiName)` Get a subject factory
    `protected org.jboss.jca.core.spi.transaction.TransactionIntegration` | `getTransactionIntegration()` Get the transaction integration.
    `protected javax.transaction.TransactionManager` | `getTransactionManager()` Get the transaction Manager.
    `protected java.net.URL[]` | `getUrls(java.io.File directory)` Get the URLs for the directory and all libraries located in the directory
    `java.lang.Object` | `initAndInject(java.lang.String className, java.util.List<? extends org.jboss.jca.common.api.metadata.spec.ConfigProperty> configs, java.lang.ClassLoader cl)` Initialize and inject configuration properties
    `protected java.util.List<javax.management.ObjectName>` | `registerManagementView(org.jboss.jca.core.api.management.Connector mgtConnector, javax.management.MBeanServer server, java.lang.String domain)` Register management view of a connector in JMX
    `protected void` | `registerResourceAdapterToMDR(java.net.URL url, java.io.File root, org.jboss.jca.common.api.metadata.spec.Connector cmd, org.jboss.jca.common.api.metadata.resourceadapter.Activation activation)` Register the ResourceAdapter to the MDR.
    `protected java.lang.String` | `registerResourceAdapterToResourceAdapterRepository(javax.resource.spi.ResourceAdapter instance)` Register the ResourceAdapter to the ResourceAdapterRepository.
    `void` | `setKernel(com.github.fungal.api.Kernel kernel)` Set the kernel
    `protected void` | `setRecoveryForResourceAdapterInResourceAdapterRepository(java.lang.String key, boolean isXA)` Set recovery mode for a resource adapter in the ResourceAdapterRepository
    `void` | `start()` Start

    - ### Methods inherited from class org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer

      `applyCapacity, associateResourceAdapter, buildJndiName, checkActivation, createCallback, createObjectsAndInjectValue, createPoolConfiguration, createSubject, findAdminObjects, findConnectionDefinitions, getBeanValidation, getConfiguration, getLogger, hasFailuresLevel, initActivationSpec, initAdminObject, printFailuresLog, requireExplicitJndiBindings, scanArchive, setCallbackSecurity, setConfiguration, startContext, validateArchive`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### kernel

          protected com.github.fungal.api.Kernel kernel

      The kernel

  - ### Constructor Detail

    - #### AbstractFungalRADeployer

          public AbstractFungalRADeployer(boolean validateClasses)

      Create a new AbstractResourceAdapterDeployer.
      Parameters:
        `validateClasses` - boolean to express if this instance will apply validation on classes structure

  - ### Method Detail

    - #### getKernel

          public com.github.fungal.api.Kernel getKernel()

      Get the kernel
      Returns:
        The kernel

    - #### setKernel

          public void setKernel(com.github.fungal.api.Kernel kernel)

      Set the kernel
      Parameters:
        `kernel` - The kernel

    - #### start

          public void start()

      Start
      Overrides:
        `start` in class `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`

    - #### initAndInject

          public java.lang.Object initAndInject(java.lang.String className,
                                                java.util.List<? extends org.jboss.jca.common.api.metadata.spec.ConfigProperty> configs,
                                                java.lang.ClassLoader cl)
                                         throws org.jboss.jca.deployers.common.DeployException

      Initialize and inject configuration properties
      Specified by:
        `initAndInject` in class `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Parameters:
        `className` - The fully qualified class name
        `configs` - The configuration properties
        `cl` - The class loader
      Returns:
        The object
      Throws:
        `org.jboss.jca.deployers.common.DeployException` - Thrown if the object cant be initialized

    - #### getUrls

          protected java.net.URL[] getUrls(java.io.File directory)
                                    throws java.net.MalformedURLException,
                                           java.io.IOException

      Get the URLs for the directory and all libraries located in the directory
      Parameters:
        `directory` - The directory
      Returns:
        The URLs
      Throws:
        `java.net.MalformedURLException` - MalformedURLException
        `java.io.IOException` - IOException

    - #### bindConnectionFactory

          public java.lang.String[] bindConnectionFactory(java.net.URL url,
                                                          java.lang.String deployment,
                                                          java.lang.Object cf)
                                                   throws java.lang.Throwable

      Description copied from class: `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Bind connection factory into JNDI
      Specified by:
        `bindConnectionFactory` in class `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Parameters:
        `url` - The deployment URL
        `deployment` - The deployment name
        `cf` - The connection factory
      Returns:
        The JNDI names bound
      Throws:
        `java.lang.Throwable` - Thrown if an error occurs

    - #### bindConnectionFactory

          public java.lang.String[] bindConnectionFactory(java.net.URL url,
                                                          java.lang.String deployment,
                                                          java.lang.Object cf,
                                                          java.lang.String jndi)
                                                   throws java.lang.Throwable

      Description copied from class: `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Bind connection factory into JNDI
      Specified by:
        `bindConnectionFactory` in class `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Parameters:
        `url` - The deployment URL
        `deployment` - The deployment name
        `cf` - The connection factory
        `jndi` - The JNDI name
      Returns:
        The JNDI names bound
      Throws:
        `java.lang.Throwable` - Thrown if an error occurs

    - #### bindAdminObject

          public java.lang.String[] bindAdminObject(java.net.URL url,
                                                    java.lang.String deployment,
                                                    java.lang.Object ao)
                                             throws java.lang.Throwable

      Description copied from class: `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Bind admin object into JNDI
      Specified by:
        `bindAdminObject` in class `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Parameters:
        `url` - The deployment URL
        `deployment` - The deployment name
        `ao` - The admin object
      Returns:
        The JNDI names bound
      Throws:
        `java.lang.Throwable` - Thrown if an error occurs

    - #### bindAdminObject

          public java.lang.String[] bindAdminObject(java.net.URL url,
                                                    java.lang.String deployment,
                                                    java.lang.Object ao,
                                                    java.lang.String jndi)
                                             throws java.lang.Throwable

      Description copied from class: `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Bind admin object into JNDI
      Specified by:
        `bindAdminObject` in class `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Parameters:
        `url` - The deployment URL
        `deployment` - The deployment name
        `ao` - The admin object
        `jndi` - The JNDI name
      Returns:
        The JNDI names bound
      Throws:
        `java.lang.Throwable` - Thrown if an error occurs

    - #### getReportDirectory

          protected java.io.File getReportDirectory()

      Description copied from class: `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      get The directory where write error reports
      Specified by:
        `getReportDirectory` in class `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Returns:
        the directory as `File`

    - #### checkConfigurationIsValid

          protected boolean checkConfigurationIsValid()

      Description copied from class: `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      check if the configuration for this deployer has been set to a valid value
      Specified by:
        `checkConfigurationIsValid` in class `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Returns:
        false if configuration is not valid

    - #### getLogPrintWriter

          protected java.io.PrintWriter getLogPrintWriter()

      Description copied from class: `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      get a PrintWriter where logger will put its output
      Specified by:
        `getLogPrintWriter` in class `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Returns:
        the printWriter for Logger

    - #### getTransactionManager

          protected javax.transaction.TransactionManager getTransactionManager()

      Description copied from class: `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Get the transaction Manager. Implementers have to provide right implementation to find and get it
      Specified by:
        `getTransactionManager` in class `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Returns:
        The value

    - #### getTransactionIntegration

          protected org.jboss.jca.core.spi.transaction.TransactionIntegration getTransactionIntegration()

      Description copied from class: `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Get the transaction integration. Implementers have to provide right implementation to find and get it
      Specified by:
        `getTransactionIntegration` in class `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Returns:
        The value

    - #### registerResourceAdapterToMDR

          protected void registerResourceAdapterToMDR(java.net.URL url,
                                                      java.io.File root,
                                                      org.jboss.jca.common.api.metadata.spec.Connector cmd,
                                                      org.jboss.jca.common.api.metadata.resourceadapter.Activation activation)
                                               throws org.jboss.jca.core.spi.mdr.AlreadyExistsException

      Description copied from class: `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Register the ResourceAdapter to the MDR. Implementer should provide the implementation to get MDR and do the registration
      Specified by:
        `registerResourceAdapterToMDR` in class `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Parameters:
        `url` - url
        `root` - root
        `cmd` - cmd
        `activation` - activation
      Throws:
        `org.jboss.jca.core.spi.mdr.AlreadyExistsException` - AlreadyExistsException

    - #### registerResourceAdapterToResourceAdapterRepository

          protected java.lang.String registerResourceAdapterToResourceAdapterRepository(javax.resource.spi.ResourceAdapter instance)

      Description copied from class: `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Register the ResourceAdapter to the ResourceAdapterRepository. Implementer should provide the implementation to get repository and do the registration
      Specified by:
        `registerResourceAdapterToResourceAdapterRepository` in class `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Parameters:
        `instance` - the instance
      Returns:
        The key

    - #### setRecoveryForResourceAdapterInResourceAdapterRepository

          protected void setRecoveryForResourceAdapterInResourceAdapterRepository(java.lang.String key,
                                                                                  boolean isXA)

      Description copied from class: `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Set recovery mode for a resource adapter in the ResourceAdapterRepository
      Specified by:
        `setRecoveryForResourceAdapterInResourceAdapterRepository` in class `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Parameters:
        `key` - The key for the resource adapter
        `isXA` - Is the resource adapter XA capable

    - #### registerManagementView

          protected java.util.List<javax.management.ObjectName> registerManagementView(org.jboss.jca.core.api.management.Connector mgtConnector,
                                                                                       javax.management.MBeanServer server,
                                                                                       java.lang.String domain)
                                                                                throws javax.management.JMException

      Register management view of a connector in JMX
      Parameters:
        `mgtConnector` - The management view of the connector
        `server` - The MBeanServer instance
        `domain` - The management domain
      Returns:
        The ObjectName's generated for this connector
      Throws:
        `javax.management.JMException` - Thrown in case of an error

    - #### getSubjectFactory

          protected org.jboss.jca.core.spi.security.SubjectFactory getSubjectFactory(org.jboss.jca.common.api.metadata.common.SecurityMetadata securityMetadata,
                                                                                     java.lang.String jndiName)
                                                                              throws org.jboss.jca.deployers.common.DeployException

      Description copied from class: `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Get a subject factory
      Specified by:
        `getSubjectFactory` in class `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Parameters:
        `securityMetadata` - The security metadata: contains the security domain and any other necessary information for returning the subject factory
        `jndiName` - optionally used for authentication context matching
      Returns:
        The subject factory; must return `null` if security domain isn't defined
      Throws:
        `org.jboss.jca.deployers.common.DeployException` - Thrown if the security domain can't be resolved

    - #### getCachedConnectionManager

          protected org.jboss.jca.core.api.connectionmanager.ccm.CachedConnectionManager getCachedConnectionManager()

      Description copied from class: `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Get the cached connection manager
      Specified by:
        `getCachedConnectionManager` in class `org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer`
      Returns:
        The handle

Copyright © 2014 IronJacamar (http://www.ironjacamar.org)